#include<iostream>
using namespace std;

const int N = 5 * 1e5 + 5;
int sum[N];
int n, m;
int lowbit(int x){
	return x & -x;
}

void add(int x, int k){
	while(x <= n){
		sum[x] += k;
		x += lowbit(x);
	}
	return;
}

int ask(int x){
	int s = 0;
	while(x){
		s += sum[x];
		x -= lowbit(x);
	}
	return s;
}

int main(){
	
	cin >> n >> m;
	
	for(int i = 1;i <= n;i ++){
		int x; cin >> x;
		add(i, x);
	}
	
	for(int i = 1;i <= m;i ++){
		int op; cin >>op;
		int a, b; cin >> a >> b;
		if(op == 1){
			add(a, b);
		}
		else cout << ask(b) - ask(a - 1) << '\n';
	}
	
	return 0;
}
